## cpuinfo 0.0~git20181219.a974884

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12 FATAL_ERROR)

INCLUDE(GNUInstallDirs)

# ---[ Project and semantic versioning.
PROJECT(cpuinfo C CXX)

# ---[ Options.
SET(CPUINFO_LIBRARY_TYPE "default" CACHE STRING "Type of cpuinfo library (shared, static, or default) to build")
SET_PROPERTY(CACHE CPUINFO_LIBRARY_TYPE PROPERTY STRINGS default static shared)
SET(CPUINFO_RUNTIME_TYPE "default" CACHE STRING "Type of runtime library (shared, static, or default) to use")
SET_PROPERTY(CACHE CPUINFO_RUNTIME_TYPE PROPERTY STRINGS default static shared)
SET(CPUINFO_LOG_LEVEL "default" CACHE STRING "Minimum logging level (info with lower severity will be ignored)")
SET_PROPERTY(CACHE CPUINFO_LOG_LEVEL PROPERTY STRINGS default debug info warning error fatal none)
OPTION(CPUINFO_BUILD_TOOLS "Build command-line tools" ON)
OPTION(CPUINFO_BUILD_UNIT_TESTS "Build cpuinfo unit tests" ON)
OPTION(CPUINFO_BUILD_MOCK_TESTS "Build cpuinfo mock tests" ON)
OPTION(CPUINFO_BUILD_BENCHMARKS "Build cpuinfo micro-benchmarks" ON)

# ---[ CMake options
IF(CPUINFO_BUILD_UNIT_TESTS OR CPUINFO_BUILD_MOCK_TESTS)
  ENABLE_TESTING()
ENDIF()

MACRO(CPUINFO_TARGET_ENABLE_C99 target)
  IF(${CMAKE_VERSION} VERSION_LESS "3.1")
    IF(NOT MSVC)
      TARGET_COMPILE_OPTIONS(${target} PRIVATE -std=c99)
    ENDIF()
  ELSE()
    SET_TARGET_PROPERTIES(${target} PROPERTIES
      C_STANDARD 99
      C_EXTENSIONS NO)
  ENDIF()
ENDMACRO()

MACRO(CPUINFO_TARGET_ENABLE_CXX11 target)
  IF(${CMAKE_VERSION} VERSION_LESS "3.1")
    IF(NOT MSVC)
      TARGET_COMPILE_OPTIONS(${target} PRIVATE -std=c++11)
    ENDIF()
  ELSE()
    SET_TARGET_PROPERTIES(${target} PROPERTIES
      CXX_STANDARD 11
      CXX_EXTENSIONS NO)
  ENDIF()
ENDMACRO()

MACRO(CPUINFO_TARGET_RUNTIME_LIBRARY target)
  IF(MSVC AND NOT CPUINFO_RUNTIME_TYPE STREQUAL "default")
    IF(CPUINFO_RUNTIME_TYPE STREQUAL "shared")
      TARGET_COMPILE_OPTIONS(${target} PRIVATE
        "/MD$<$<CONFIG:Debug>:d>")
    ELSEIF(CPUINFO_RUNTIME_TYPE STREQUAL "static")
      TARGET_COMPILE_OPTIONS(${target} PRIVATE
        "/MT$<$<CONFIG:Debug>:d>")
    ENDIF()
  ENDIF()
ENDMACRO()

# ---[ Build flags
SET(CPUINFO_SUPPORTED_PLATFORM TRUE)
IF(NOT CMAKE_SYSTEM_PROCESSOR)
  IF(NOT IOS)
    MESSAGE(WARNING
      "Target processor architecture is not specified. "
      "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
    SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
  ENDIF()
ELSEIF(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|AMD64|x86(_64)?|armv[5-8].*|aarch64)$")
  MESSAGE(WARNING
    "Target processor architecture \"${CMAKE_SYSTEM_PROCESSOR}\" is not supported in cpuinfo. "
    "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
  SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
ENDIF()

IF(NOT CMAKE_SYSTEM_NAME)
    MESSAGE(WARNING
      "Target operating system is not specified. "
      "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
  SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
ELSEIF(NOT CMAKE_SYSTEM_NAME MATCHES "^(Windows|Darwin|Linux|Android)$")
  MESSAGE(WARNING
    "Target operating system \"${CMAKE_SYSTEM_NAME}\" is not supported in cpuinfo. "
    "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
  SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
ENDIF()

# ---[ Download deps
SET(CONFU_DEPENDENCIES_SOURCE_DIR ${CMAKE_SOURCE_DIR}/deps
  CACHE PATH "Confu-style dependencies source directory")
SET(CONFU_DEPENDENCIES_BINARY_DIR ${CMAKE_BINARY_DIR}/deps
  CACHE PATH "Confu-style dependencies binary directory")

IF(CPUINFO_BUILD_MOCK_TESTS OR CPUINFO_BUILD_UNIT_TESTS)
  IF(CPUINFO_SUPPORTED_PLATFORM AND NOT DEFINED GOOGLETEST_SOURCE_DIR)
    MESSAGE(STATUS "Downloading Google Test to ${CONFU_DEPENDENCIES_SOURCE_DIR}/googletest (define GOOGLETEST_SOURCE_DIR to avoid it)")
    CONFIGURE_FILE(cmake/DownloadGoogleTest.cmake "${CONFU_DEPENDENCIES_BINARY_DIR}/googletest-download/CMakeLists.txt")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
      WORKING_DIRECTORY "${CONFU_DEPENDENCIES_BINARY_DIR}/googletest-download")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
      WORKING_DIRECTORY "${CONFU_DEPENDENCIES_BINARY_DIR}/googletest-download")
    SET(GOOGLETEST_SOURCE_DIR "${CONFU_DEPENDENCIES_SOURCE_DIR}/googletest" CACHE STRING "Google Test source directory")
  ENDIF()
ENDIF()

IF(CPUINFO_BUILD_BENCHMARKS)
  IF(CPUINFO_SUPPORTED_PLATFORM AND NOT DEFINED GOOGLEBENCHMARK_SOURCE_DIR)
    MESSAGE(STATUS "Downloading Google Benchmark to ${CONFU_DEPENDENCIES_SOURCE_DIR}/googlebenchmark (define GOOGLEBENCHMARK_SOURCE_DIR to avoid it)")
    CONFIGURE_FILE(cmake/DownloadGoogleBenchmark.cmake "${CONFU_DEPENDENCIES_BINARY_DIR}/googlebenchmark-download/CMakeLists.txt")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
      WORKING_DIRECTORY "${CONFU_DEPENDENCIES_BINARY_DIR}/googlebenchmark-download")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
      WORKING_DIRECTORY "${CONFU_DEPENDENCIES_BINARY_DIR}/googlebenchmark-download")
    SET(GOOGLEBENCHMARK_SOURCE_DIR "${CONFU_DEPENDENCIES_SOURCE_DIR}/googlebenchmark" CACHE STRING "Google Benchmark source directory")
  ENDIF()
ENDIF()

# ---[ cpuinfo library
SET(CPUINFO_SRCS
  src/init.c
  src/api.c)

IF(CPUINFO_SUPPORTED_PLATFORM)
  IF(CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|AMD64|x86(_64)?)$" OR IOS_ARCH MATCHES "^(i386|x86_64)$")
    LIST(APPEND CPUINFO_SRCS
      src/x86/init.c
      src/x86/info.c
      src/x86/vendor.c
      src/x86/uarch.c
      src/x86/name.c
      src/x86/topology.c
      src/x86/isa.c
      src/x86/cache/init.c
      src/x86/cache/descriptor.c
      src/x86/cache/deterministic.c)
    IF(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "Android")
      LIST(APPEND CPUINFO_SRCS
        src/x86/linux/init.c
        src/x86/linux/cpuinfo.c)
    ELSEIF(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
      LIST(APPEND CPUINFO_SRCS src/x86/mach/init.c)
    ELSEIF(CMAKE_SYSTEM_NAME STREQUAL "Windows")
      LIST(APPEND CPUINFO_SRCS src/x86/windows/init.c)
    ENDIF()
  ELSEIF(CMAKE_SYSTEM_PROCESSOR MATCHES "^(armv[5-8].*|aarch64)$" OR IOS_ARCH MATCHES "^(armv7.*|arm64.*)$")
    LIST(APPEND CPUINFO_SRCS
      src/arm/uarch.c
      src/arm/cache.c)
    IF(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "Android")
      LIST(APPEND CPUINFO_SRCS
        src/arm/linux/init.c
        src/arm/linux/cpuinfo.c
        src/arm/linux/clusters.c
        src/arm/linux/chipset.c
        src/arm/linux/midr.c
        src/arm/linux/hwcap.c)
      IF(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv[5-8]")
        LIST(APPEND CPUINFO_SRCS src/arm/linux/aarch32-isa.c)
        IF(CMAKE_SYSTEM_NAME STREQUAL "Android" AND ANDROID_ABI STREQUAL "armeabi")
          SET_SOURCE_FILES_PROPERTIES(src/arm/linux/aarch32-isa.c PROPERTIES COMPILE_FLAGS -marm)
        ENDIF()
      ELSEIF(CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
        LIST(APPEND CPUINFO_SRCS src/arm/linux/aarch64-isa.c)
      ENDIF()
    ELSEIF(IOS)
      LIST(APPEND CPUINFO_SRCS src/arm/mach/init.c)
    ENDIF()
    IF(CMAKE_SYSTEM_NAME STREQUAL "Android")
      LIST(APPEND CPUINFO_SRCS
        src/arm/android/properties.c)
    ENDIF()
  ENDIF()

  IF(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "Android")
    LIST(APPEND CPUINFO_SRCS
      src/linux/smallfile.c
      src/linux/multiline.c
      src/linux/current.c
      src/linux/cpulist.c
      src/linux/processors.c)
  ELSEIF(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
    LIST(APPEND CPUINFO_SRCS src/mach/topology.c)
  ENDIF()

  IF(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "Android")
    SET(CMAKE_THREAD_PREFER_PTHREAD TRUE)
    SET(THREADS_PREFER_PTHREAD_FLAG TRUE)
    FIND_PACKAGE(Threads REQUIRED)
  ENDIF()
ENDIF()

IF(CPUINFO_LIBRARY_TYPE STREQUAL "default")
  ADD_LIBRARY(cpuinfo ${CPUINFO_SRCS})
ELSEIF(CPUINFO_LIBRARY_TYPE STREQUAL "shared")
  ADD_LIBRARY(cpuinfo SHARED ${CPUINFO_SRCS})
ELSEIF(CPUINFO_LIBRARY_TYPE STREQUAL "static")
  ADD_LIBRARY(cpuinfo STATIC ${CPUINFO_SRCS})
ELSE()
  MESSAGE(FATAL_ERROR "Unsupported library type ${CPUINFO_LIBRARY_TYPE}")
ENDIF()
ADD_LIBRARY(cpuinfo_internals STATIC ${CPUINFO_SRCS})
CPUINFO_TARGET_ENABLE_C99(cpuinfo)
CPUINFO_TARGET_ENABLE_C99(cpuinfo_internals)
CPUINFO_TARGET_RUNTIME_LIBRARY(cpuinfo)
SET_TARGET_PROPERTIES(cpuinfo PROPERTIES PUBLIC_HEADER include/cpuinfo.h)
TARGET_INCLUDE_DIRECTORIES(cpuinfo BEFORE PUBLIC include)
TARGET_INCLUDE_DIRECTORIES(cpuinfo BEFORE PRIVATE src)
TARGET_INCLUDE_DIRECTORIES(cpuinfo_internals BEFORE PUBLIC include src)
IF(CPUINFO_LOG_LEVEL STREQUAL "default")
  # default logging level: error (subject to change)
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=4)
ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "debug")
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=5)
ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "info")
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=4)
ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "warning")
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=3)
ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "error")
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=2)
ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "fatal")
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=1)
ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "none")
  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=0)
ELSE()
  MESSAGE(FATAL_ERROR "Unsupported logging level ${CPUINFO_LOG_LEVEL}")
ENDIF()
TARGET_COMPILE_DEFINITIONS(cpuinfo_internals PRIVATE CPUINFO_LOG_LEVEL=0)

IF(CPUINFO_SUPPORTED_PLATFORM)
  TARGET_COMPILE_DEFINITIONS(cpuinfo INTERFACE CPUINFO_SUPPORTED_PLATFORM=1)
  IF(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "Android")
    TARGET_LINK_LIBRARIES(cpuinfo PUBLIC ${CMAKE_THREAD_LIBS_INIT})
    TARGET_LINK_LIBRARIES(cpuinfo_internals PUBLIC ${CMAKE_THREAD_LIBS_INIT})
    TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE _GNU_SOURCE=1)
    TARGET_COMPILE_DEFINITIONS(cpuinfo_internals PRIVATE _GNU_SOURCE=1)
  ENDIF()
ELSE()
  TARGET_COMPILE_DEFINITIONS(cpuinfo INTERFACE CPUINFO_SUPPORTED_PLATFORM=0)
ENDIF()

# ---[ cpuinfo dependencies: clog
IF(NOT DEFINED CLOG_SOURCE_DIR)
  SET(CLOG_SOURCE_DIR "${PROJECT_SOURCE_DIR}/deps/clog")
ENDIF()
IF(NOT TARGET clog)
  SET(CLOG_BUILD_TESTS OFF CACHE BOOL "")
  SET(CLOG_RUNTIME_TYPE "${CPUINFO_RUNTIME_TYPE}" CACHE STRING "")
  ADD_SUBDIRECTORY(
    "${CLOG_SOURCE_DIR}")
  # We build static version of clog but a dynamic library may indirectly depend on it
  SET_PROPERTY(TARGET clog PROPERTY POSITION_INDEPENDENT_CODE ON)
ENDIF()
TARGET_LINK_LIBRARIES(cpuinfo PRIVATE clog)
TARGET_LINK_LIBRARIES(cpuinfo_internals PRIVATE clog)

INSTALL(TARGETS cpuinfo
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# ---[ cpuinfo micro-benchmarks
IF(CPUINFO_SUPPORTED_PLATFORM AND CPUINFO_BUILD_BENCHMARKS)
  # ---[ Build google benchmark
  IF(NOT TARGET benchmark)
    SET(BENCHMARK_ENABLE_TESTING OFF CACHE BOOL "")
    ADD_SUBDIRECTORY(
      "${GOOGLEBENCHMARK_SOURCE_DIR}"
      "${CONFU_DEPENDENCIES_BINARY_DIR}/googlebenchmark")
  ENDIF()

  IF(CMAKE_SYSTEM_NAME MATCHES "^(Linux|Android)$")
    ADD_EXECUTABLE(get-current-bench bench/get-current.cc)
    TARGET_LINK_LIBRARIES(get-current-bench cpuinfo benchmark)
  ENDIF()

  ADD_EXECUTABLE(init-bench bench/init.cc)
  TARGET_LINK_LIBRARIES(init-bench cpuinfo benchmark)
ENDIF()

IF(CPUINFO_SUPPORTED_PLATFORM)
  IF(CPUINFO_BUILD_MOCK_TESTS OR CPUINFO_BUILD_UNIT_TESTS)
    # ---[ Build google test
    IF(NOT TARGET gtest)
      IF(MSVC AND NOT CPUINFO_RUNTIME_TYPE STREQUAL "static")
        SET(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
      ENDIF()
      ADD_SUBDIRECTORY(
        "${GOOGLETEST_SOURCE_DIR}"
        "${CONFU_DEPENDENCIES_BINARY_DIR}/googletest")
    ENDIF()
  ENDIF()
ENDIF()

# ---[ cpuinfo mock library and mock tests
IF(CPUINFO_SUPPORTED_PLATFORM AND CPUINFO_BUILD_MOCK_TESTS)

=== debian/changelog ===
cpuinfo (0.0~git20181219.a974884-2) unstable; urgency=medium

  * Allow output to stderr during autopkgtest.
  * Change default log level to "warning" to make the library quiet.
    (Closes: #918177)

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 05 Jan 2019 02:01:09 +0000

cpuinfo (0.0~git20181219.a974884-1) unstable; urgency=medium

  * New upstream version 0.0~git20181219.a974884
  * Fix FTBFS on i386, due to missing shared object in ld's path.
  * Fix FTBFS on arm* because files to be installed diverges from x86.
  * Add watch file to monitor upstream git HEAD.
  * Refresh symbols control file.
  * Dump cpu information before running tests, for debugging purpose.

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 19 Dec 2018 12:09:13 +0000

cpuinfo (0.0~git20181113.3bf2c72-1) unstable; urgency=low

  * Initial release. (Closes: #915979)

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 09 Dec 2018 06:03:10 +0000

=== debian/control ===
Source: cpuinfo
Section: science
Homepage: https://github.com/pytorch/cpuinfo
Priority: optional
Standards-Version: 4.2.1
Vcs-Git: https://salsa.debian.org/deeplearning-team/cpuinfo.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/cpuinfo
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <cdluminate@gmail.com>,
Build-Depends: debhelper (>= 11~), googletest, cmake,

Package: cpuinfo
Architecture: any
Multi-Arch: no
Depends: ${shlibs:Depends}, ${misc:Depends}, libcpuinfo0 (= ${binary:Version}),
Description: CPU INFOrmation library (binary utilities)
 cpuinfo is a library to detect essential for performance optimization
 information about host CPU.
 .
 Features
 .
   - **Cross-platform** availability:
     - Linux, Windows, macOS, Android, and iOS operating systems
     - x86, x86-64, ARM, and ARM64 architectures
   - Modern **C/C++ interface**
     - Thread-safe
     - No memory allocation after initialization
     - No exceptions thrown
   - Detection of **supported instruction sets**, up to AVX512 (x86) and
     ARMv8.3 extensions
   - Detection of SoC and core information:
     - **Processor (SoC) name**
     - Integrated **GPU name** (Android/iOS only)
     - Vendor, **microarchitecture**, and ID (**MIDR** on ARM, **CPUID**
       leaf 1 EAX value on x86) for each CPU core
   - Detection of **cache information**:
     - Cache type (instruction/data/unified), size and line size
     - Cache associativity
     - Cores and logical processors (hyper-threads) sharing the cache
   - Detection of **topology information** (relative between logical
     processors, cores, and processor packages)
   - Well-tested **production-quality** code:
     - 60+ mock tests based on data from real devices
     - Includes work-arounds for common bugs in hardware and OS kernels
     - Supports systems with heterogenous cores, such as **big.LITTLE**
       and Max.Med.Min
   - Permissive **open-source** license (Simplified BSD)
 .
 This package ships with several binary utilities.

Package: libcpuinfo-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libcpuinfo0 (= ${binary:Version}),
Description: CPU INFOrmation library (header file)
 cpuinfo is a library to detect essential for performance optimization
 information about host CPU.
 .
 Features
 .
   - **Cross-platform** availability:
     - Linux, Windows, macOS, Android, and iOS operating systems
     - x86, x86-64, ARM, and ARM64 architectures
   - Modern **C/C++ interface**
     - Thread-safe
     - No memory allocation after initialization
     - No exceptions thrown
   - Detection of **supported instruction sets**, up to AVX512 (x86) and
     ARMv8.3 extensions
   - Detection of SoC and core information:
     - **Processor (SoC) name**
     - Integrated **GPU name** (Android/iOS only)
     - Vendor, **microarchitecture**, and ID (**MIDR** on ARM, **CPUID**
       leaf 1 EAX value on x86) for each CPU core
   - Detection of **cache information**:
     - Cache type (instruction/data/unified), size and line size
     - Cache associativity
     - Cores and logical processors (hyper-threads) sharing the cache
   - Detection of **topology information** (relative between logical
     processors, cores, and processor packages)
   - Well-tested **production-quality** code:
     - 60+ mock tests based on data from real devices
     - Includes work-arounds for common bugs in hardware and OS kernels
     - Supports systems with heterogenous cores, such as **big.LITTLE**
       and Max.Med.Min
   - Permissive **open-source** license (Simplified BSD)
 .
 This package ships with the header file.

Package: libcpuinfo0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: CPU INFOrmation library (shared object)
 cpuinfo is a library to detect essential for performance optimization
 information about host CPU.
 .
 Features
 .
   - **Cross-platform** availability:
     - Linux, Windows, macOS, Android, and iOS operating systems
     - x86, x86-64, ARM, and ARM64 architectures
   - Modern **C/C++ interface**
     - Thread-safe
     - No memory allocation after initialization
     - No exceptions thrown
   - Detection of **supported instruction sets**, up to AVX512 (x86) and
     ARMv8.3 extensions
   - Detection of SoC and core information:
     - **Processor (SoC) name**
     - Integrated **GPU name** (Android/iOS only)
     - Vendor, **microarchitecture**, and ID (**MIDR** on ARM, **CPUID**
       leaf 1 EAX value on x86) for each CPU core
   - Detection of **cache information**:
     - Cache type (instruction/data/unified), size and line size
     - Cache associativity
     - Cores and logical processors (hyper-threads) sharing the cache
   - Detection of **topology information** (relative between logical
     processors, cores, and processor packages)
   - Well-tested **production-quality** code:
     - 60+ mock tests based on data from real devices
     - Includes work-arounds for common bugs in hardware and OS kernels
     - Supports systems with heterogenous cores, such as **big.LITTLE**
       and Max.Med.Min
   - Permissive **open-source** license (Simplified BSD)
 .
 This package ships with the shared object.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DGOOGLETEST_SOURCE_DIR=/usr/src/googletest/ \
		-DCPUINFO_BUILD_BENCHMARKS=OFF \
		-DCPUINFO_LIBRARY_TYPE=shared \
		-DCPUINFO_LOG_LEVEL=warning \
		-DCMAKE_SKIP_RPATH=ON
	# arch-specific install file
	if [ -r debian/cpuinfo.install.$(DEB_HOST_ARCH) ]; then \
		cp debian/cpuinfo.install.$(DEB_HOST_ARCH) debian/cpuinfo.install; \
		fi

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	if [ -r /proc/cpuinfo ]; then cat /proc/cpuinfo ; else false; fi
	if [ -x ./$(shell ls -d obj-*)/cpuid-dump ]; then ./$(shell ls -d obj-*)/cpuid-dump; fi
	LD_LIBRARY_PATH=$(shell pwd)/$(shell ls -d obj-*) dh_auto_test
endif

override_dh_missing:
	dh_missing --list-missing

## cpuinfo 0.0~git20181227.2d2bfa4

=== CMakeLists.txt ===
--- 
+++ 
@@ -209,7 +209,7 @@
 TARGET_INCLUDE_DIRECTORIES(cpuinfo_internals BEFORE PUBLIC include src)
 IF(CPUINFO_LOG_LEVEL STREQUAL "default")
   # default logging level: error (subject to change)
-  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=4)
+  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=2)
 ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "debug")
   TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE CPUINFO_LOG_LEVEL=5)
 ELSEIF(CPUINFO_LOG_LEVEL STREQUAL "info")

=== debian/changelog ===
cpuinfo (0.0~git20181227.2d2bfa4-1) unstable; urgency=medium

  * New upstream version 0.0~git20181227.2d2bfa4
  * Bump Standards-Version to 4.3.0 (no change).
  * Bump debhelper compat to 12.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 12 Jan 2019 05:33:49 +0000

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Section: science
 Homepage: https://github.com/pytorch/cpuinfo
 Priority: optional
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Vcs-Git: https://salsa.debian.org/deeplearning-team/cpuinfo.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/cpuinfo
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Mo Zhou <cdluminate@gmail.com>,
-Build-Depends: debhelper (>= 11~), googletest, cmake,
+Build-Depends: debhelper (>= 12~), googletest, cmake,
 
 Package: cpuinfo
 Architecture: any

## cpuinfo 0.0~git20190118.da0a91b

=== debian/changelog ===
cpuinfo (0.0~git20190118.da0a91b-1) unstable; urgency=medium

  [ Alexander GQ Gerasiov ]
  * Add debian/patches/add-binaries-install.patch instead of
    arch-specific cpuinfo.install files.
  * d/control: Limit Architecture with only supported ones.

  [ Mo Zhou ]
  * New upstream version 0.0~git20190118.da0a91b

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 30 Jan 2019 02:02:25 +0000

## cpuinfo 0.0~git20190201.d5e37ad

=== debian/changelog ===
cpuinfo (0.0~git20190201.d5e37ad-2) unstable; urgency=medium

  [ Rafael David Tinoco ]
  * debian/rules: Set CPUINFO_LOG_LEVEL to error only (LP: #1840847)

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 22 Aug 2019 07:01:35 +0000

cpuinfo (0.0~git20190201.d5e37ad-1) unstable; urgency=medium

  * New upstream version 0.0~git20190201.d5e37ad
  * Remove add-binaries-install.patch, merged upstream.

 -- Mo Zhou <cdluminate@gmail.com>  Mon, 04 Feb 2019 06:36:46 +0000

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Build-Depends: debhelper (>= 12~), googletest, cmake,
 
 Package: cpuinfo
-Architecture: any
+Architecture: amd64 arm64 armel armhf i386 x32
 Multi-Arch: no
 Depends: ${shlibs:Depends}, ${misc:Depends}, libcpuinfo0 (= ${binary:Version}),
 Description: CPU INFOrmation library (binary utilities)
@@ -50,7 +50,7 @@
 
 Package: libcpuinfo-dev
 Section: libdevel
-Architecture: any
+Architecture: amd64 arm64 armel armhf i386 x32
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, libcpuinfo0 (= ${binary:Version}),
 Description: CPU INFOrmation library (header file)
@@ -90,7 +90,7 @@
 
 Package: libcpuinfo0
 Section: libs
-Architecture: any
+Architecture: amd64 arm64 armel armhf i386 x32
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends},
 Description: CPU INFOrmation library (shared object)

=== debian/rules ===
--- 
+++ 
@@ -9,12 +9,8 @@
 		-DGOOGLETEST_SOURCE_DIR=/usr/src/googletest/ \
 		-DCPUINFO_BUILD_BENCHMARKS=OFF \
 		-DCPUINFO_LIBRARY_TYPE=shared \
-		-DCPUINFO_LOG_LEVEL=warning \
+		-DCPUINFO_LOG_LEVEL=error \
 		-DCMAKE_SKIP_RPATH=ON
-	# arch-specific install file
-	if [ -r debian/cpuinfo.install.$(DEB_HOST_ARCH) ]; then \
-		cp debian/cpuinfo.install.$(DEB_HOST_ARCH) debian/cpuinfo.install; \
-		fi
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

## cpuinfo 0.0~git20200422.a1e0b95

=== CMakeLists.txt ===
--- 
+++ 
@@ -80,10 +80,12 @@
       "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
   SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
 ELSEIF(NOT CMAKE_SYSTEM_NAME MATCHES "^(Windows|Darwin|Linux|Android)$")
-  MESSAGE(WARNING
-    "Target operating system \"${CMAKE_SYSTEM_NAME}\" is not supported in cpuinfo. "
-    "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
-  SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
+  IF(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.14" AND NOT CMAKE_SYSTEM_NAME STREQUAL "iOS")
+    MESSAGE(WARNING
+      "Target operating system \"${CMAKE_SYSTEM_NAME}\" is not supported in cpuinfo. "
+      "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
+    SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
+  ENDIF()
 ENDIF()
 
 # ---[ Download deps
@@ -119,7 +121,8 @@
 # ---[ cpuinfo library
 SET(CPUINFO_SRCS
   src/init.c
-  src/api.c)
+  src/api.c
+  src/cache.c)
 
 IF(CPUINFO_SUPPORTED_PLATFORM)
   IF(CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|AMD64|x86(_64)?)$" OR IOS_ARCH MATCHES "^(i386|x86_64)$")
@@ -138,7 +141,7 @@
       LIST(APPEND CPUINFO_SRCS
         src/x86/linux/init.c
         src/x86/linux/cpuinfo.c)
-    ELSEIF(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
+    ELSEIF(CMAKE_SYSTEM_NAME STREQUAL "Darwin" OR CMAKE_SYSTEM_NAME STREQUAL "iOS")
       LIST(APPEND CPUINFO_SRCS src/x86/mach/init.c)
     ELSEIF(CMAKE_SYSTEM_NAME STREQUAL "Windows")
       LIST(APPEND CPUINFO_SRCS src/x86/windows/init.c)
@@ -176,10 +179,9 @@
     LIST(APPEND CPUINFO_SRCS
       src/linux/smallfile.c
       src/linux/multiline.c
-      src/linux/current.c
       src/linux/cpulist.c
       src/linux/processors.c)
-  ELSEIF(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
+  ELSEIF(CMAKE_SYSTEM_NAME STREQUAL "Darwin" OR CMAKE_SYSTEM_NAME STREQUAL "iOS")
     LIST(APPEND CPUINFO_SRCS src/mach/topology.c)
   ENDIF()
 
@@ -287,10 +289,3 @@
       ENDIF()
       ADD_SUBDIRECTORY(
         "${GOOGLETEST_SOURCE_DIR}"
-        "${CONFU_DEPENDENCIES_BINARY_DIR}/googletest")
-    ENDIF()
-  ENDIF()
-ENDIF()
-
-# ---[ cpuinfo mock library and mock tests
-IF(CPUINFO_SUPPORTED_PLATFORM AND CPUINFO_BUILD_MOCK_TESTS)

=== debian/changelog ===
cpuinfo (0.0~git20200422.a1e0b95-2) unstable; urgency=medium

  * Install libclog.a and clog.h in libcpuinfo-dev,
    as clog is used by too many reverse dependencies.
  * Bump debhelper compat level to 13.
  * Apply wrap-and-sort.

 -- Mo Zhou <lumin@debian.org>  Thu, 30 Apr 2020 23:05:06 +0800

cpuinfo (0.0~git20200422.a1e0b95-1) unstable; urgency=medium

  * New upstream version 0.0~git20200422.a1e0b95
  * Incorporate upstream LICENSE updates to d/copyright.
  * Update my mail address in control and d/copyright.
  * Bump Standards-Version to 4.5.0 (no change).
  * Specify Rules-Requires-Root: no.
  * Specify Build-Depends-Package in symbols control file.
  * Refresh symbols control file (new symbols)
  * B-D on debhelper-compat (= 12) and deprecate d/compat.

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Apr 2020 13:35:55 +0800

=== debian/control ===
--- 
+++ 
@@ -2,17 +2,18 @@
 Section: science
 Homepage: https://github.com/pytorch/cpuinfo
 Priority: optional
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/deeplearning-team/cpuinfo.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/cpuinfo
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Mo Zhou <cdluminate@gmail.com>,
-Build-Depends: debhelper (>= 12~), googletest, cmake,
+Uploaders: Mo Zhou <lumin@debian.org>
+Build-Depends: cmake, debhelper-compat (= 13), googletest
+Rules-Requires-Root: no
 
 Package: cpuinfo
 Architecture: amd64 arm64 armel armhf i386 x32
 Multi-Arch: no
-Depends: ${shlibs:Depends}, ${misc:Depends}, libcpuinfo0 (= ${binary:Version}),
+Depends: libcpuinfo0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: CPU INFOrmation library (binary utilities)
  cpuinfo is a library to detect essential for performance optimization
  information about host CPU.
@@ -52,7 +53,7 @@
 Section: libdevel
 Architecture: amd64 arm64 armel armhf i386 x32
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libcpuinfo0 (= ${binary:Version}),
+Depends: libcpuinfo0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: CPU INFOrmation library (header file)
  cpuinfo is a library to detect essential for performance optimization
  information about host CPU.
@@ -92,7 +93,7 @@
 Section: libs
 Architecture: amd64 arm64 armel armhf i386 x32
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends},
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: CPU INFOrmation library (shared object)
  cpuinfo is a library to detect essential for performance optimization
  information about host CPU.

## cpuinfo 0.0~git20200612.63b2545

=== CMakeLists.txt ===
--- 
+++ 
@@ -79,7 +79,7 @@
       "Target operating system is not specified. "
       "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
   SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
-ELSEIF(NOT CMAKE_SYSTEM_NAME MATCHES "^(Windows|Darwin|Linux|Android)$")
+ELSEIF(NOT CMAKE_SYSTEM_NAME MATCHES "^(Windows|CYGWIN|MSYS|Darwin|Linux|Android)$")
   IF(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.14" AND NOT CMAKE_SYSTEM_NAME STREQUAL "iOS")
     MESSAGE(WARNING
       "Target operating system \"${CMAKE_SYSTEM_NAME}\" is not supported in cpuinfo. "
@@ -125,7 +125,7 @@
   src/cache.c)
 
 IF(CPUINFO_SUPPORTED_PLATFORM)
-  IF(CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|AMD64|x86(_64)?)$" OR IOS_ARCH MATCHES "^(i386|x86_64)$")
+  IF(NOT CMAKE_SYSTEM_NAME STREQUAL "Emscripten" AND (CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|AMD64|x86(_64)?)$" OR IOS_ARCH MATCHES "^(i386|x86_64)$"))
     LIST(APPEND CPUINFO_SRCS
       src/x86/init.c
       src/x86/info.c
@@ -143,7 +143,7 @@
         src/x86/linux/cpuinfo.c)
     ELSEIF(CMAKE_SYSTEM_NAME STREQUAL "Darwin" OR CMAKE_SYSTEM_NAME STREQUAL "iOS")
       LIST(APPEND CPUINFO_SRCS src/x86/mach/init.c)
-    ELSEIF(CMAKE_SYSTEM_NAME STREQUAL "Windows")
+    ELSEIF(CMAKE_SYSTEM_NAME MATCHES "^(Windows|CYGWIN|MSYS)$")
       LIST(APPEND CPUINFO_SRCS src/x86/windows/init.c)
     ENDIF()
   ELSEIF(CMAKE_SYSTEM_PROCESSOR MATCHES "^(armv[5-8].*|aarch64)$" OR IOS_ARCH MATCHES "^(armv7.*|arm64.*)$")
@@ -175,6 +175,11 @@
     ENDIF()
   ENDIF()
 
+  IF(CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
+    LIST(APPEND CPUINFO_SRCS
+      src/emscripten/init.c)
+  ENDIF()
+
   IF(CMAKE_SYSTEM_NAME STREQUAL "Linux" OR CMAKE_SYSTEM_NAME STREQUAL "Android")
     LIST(APPEND CPUINFO_SRCS
       src/linux/smallfile.c
@@ -205,6 +210,11 @@
 CPUINFO_TARGET_ENABLE_C99(cpuinfo)
 CPUINFO_TARGET_ENABLE_C99(cpuinfo_internals)
 CPUINFO_TARGET_RUNTIME_LIBRARY(cpuinfo)
+IF(CMAKE_SYSTEM_NAME MATCHES "^(Windows|CYGWIN|MSYS)$")
+  # Target Windows 7+ API
+  TARGET_COMPILE_DEFINITIONS(cpuinfo PRIVATE _WIN32_WINNT=0x0601)
+  TARGET_COMPILE_DEFINITIONS(cpuinfo_internals PRIVATE _WIN32_WINNT=0x0601)
+ENDIF()
 SET_TARGET_PROPERTIES(cpuinfo PROPERTIES PUBLIC_HEADER include/cpuinfo.h)
 TARGET_INCLUDE_DIRECTORIES(cpuinfo BEFORE PUBLIC include)
 TARGET_INCLUDE_DIRECTORIES(cpuinfo BEFORE PRIVATE src)
@@ -277,15 +287,3 @@
   ENDIF()
 
   ADD_EXECUTABLE(init-bench bench/init.cc)
-  TARGET_LINK_LIBRARIES(init-bench cpuinfo benchmark)
-ENDIF()
-
-IF(CPUINFO_SUPPORTED_PLATFORM)
-  IF(CPUINFO_BUILD_MOCK_TESTS OR CPUINFO_BUILD_UNIT_TESTS)
-    # ---[ Build google test
-    IF(NOT TARGET gtest)
-      IF(MSVC AND NOT CPUINFO_RUNTIME_TYPE STREQUAL "static")
-        SET(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
-      ENDIF()
-      ADD_SUBDIRECTORY(
-        "${GOOGLETEST_SOURCE_DIR}"

=== debian/changelog ===
cpuinfo (0.0~git20200612.63b2545-2) unstable; urgency=medium

  * Allow building libcpuinfo{0,-dev} on other architectures.
  * Change maintainer to Deep Learning Team <debian-ai@l.d.o>.
  * Please pin to this upstream snapshot for PyTorch 1.7.0.

 -- Mo Zhou <lumin@debian.org>  Thu, 29 Oct 2020 13:28:03 +0800

cpuinfo (0.0~git20200612.63b2545-1) unstable; urgency=medium

  * New upstream version 0.0~git20200612.63b2545
  * Refresh symbols control file (+1 new symbol)

 -- Mo Zhou <lumin@debian.org>  Mon, 31 Aug 2020 10:14:21 +0800

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/deeplearning-team/cpuinfo.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/cpuinfo
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>
 Build-Depends: cmake, debhelper-compat (= 13), googletest
 Rules-Requires-Root: no
@@ -51,7 +51,7 @@
 
 Package: libcpuinfo-dev
 Section: libdevel
-Architecture: amd64 arm64 armel armhf i386 x32
+Architecture: any
 Multi-Arch: same
 Depends: libcpuinfo0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: CPU INFOrmation library (header file)
@@ -91,7 +91,7 @@
 
 Package: libcpuinfo0
 Section: libs
-Architecture: amd64 arm64 armel armhf i386 x32
+Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: CPU INFOrmation library (shared object)

## cpuinfo 0.0~git20201217.5916273

=== debian/changelog ===
cpuinfo (0.0~git20201217.5916273-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Thu, 02 Sep 2021 02:05:57 +0000

cpuinfo (0.0~git20201217.5916273-1) experimental; urgency=medium

  * New upstream version 0.0~git20201217.5916273
    Please pin to this snapshot for PyTorch/v1.8.1
  * Refresh existing patches.

 -- Mo Zhou <lumin@debian.org>  Wed, 19 May 2021 13:03:47 +0800

## cpuinfo 0.0~git20220131.85e931e

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,10 @@
-CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12 FATAL_ERROR)
-
-INCLUDE(GNUInstallDirs)
-
-# ---[ Project and semantic versioning.
-PROJECT(cpuinfo C CXX)
+CMAKE_MINIMUM_REQUIRED(VERSION 3.5 FATAL_ERROR)
+
+# ---[ Setup project
+PROJECT(
+    cpuinfo
+    LANGUAGES C CXX
+    )
 
 # ---[ Options.
 SET(CPUINFO_LIBRARY_TYPE "default" CACHE STRING "Type of cpuinfo library (shared, static, or default) to build")
@@ -16,34 +17,25 @@
 OPTION(CPUINFO_BUILD_UNIT_TESTS "Build cpuinfo unit tests" ON)
 OPTION(CPUINFO_BUILD_MOCK_TESTS "Build cpuinfo mock tests" ON)
 OPTION(CPUINFO_BUILD_BENCHMARKS "Build cpuinfo micro-benchmarks" ON)
+OPTION(CPUINFO_BUILD_PKG_CONFIG "Build pkg-config manifest" ON)
 
 # ---[ CMake options
+INCLUDE(GNUInstallDirs)
+
 IF(CPUINFO_BUILD_UNIT_TESTS OR CPUINFO_BUILD_MOCK_TESTS)
   ENABLE_TESTING()
 ENDIF()
 
 MACRO(CPUINFO_TARGET_ENABLE_C99 target)
-  IF(${CMAKE_VERSION} VERSION_LESS "3.1")
-    IF(NOT MSVC)
-      TARGET_COMPILE_OPTIONS(${target} PRIVATE -std=c99)
-    ENDIF()
-  ELSE()
-    SET_TARGET_PROPERTIES(${target} PROPERTIES
-      C_STANDARD 99
-      C_EXTENSIONS NO)
-  ENDIF()
+  SET_TARGET_PROPERTIES(${target} PROPERTIES
+    C_STANDARD 99
+    C_EXTENSIONS NO)
 ENDMACRO()
 
 MACRO(CPUINFO_TARGET_ENABLE_CXX11 target)
-  IF(${CMAKE_VERSION} VERSION_LESS "3.1")
-    IF(NOT MSVC)
-      TARGET_COMPILE_OPTIONS(${target} PRIVATE -std=c++11)
-    ENDIF()
-  ELSE()
-    SET_TARGET_PROPERTIES(${target} PROPERTIES
-      CXX_STANDARD 11
-      CXX_EXTENSIONS NO)
-  ENDIF()
+  SET_TARGET_PROPERTIES(${target} PROPERTIES
+    CXX_STANDARD 11
+    CXX_EXTENSIONS NO)
 ENDMACRO()
 
 MACRO(CPUINFO_TARGET_RUNTIME_LIBRARY target)
@@ -58,6 +50,12 @@
   ENDIF()
 ENDMACRO()
 
+# -- [ Determine target processor
+SET(CPUINFO_TARGET_PROCESSOR "${CMAKE_SYSTEM_PROCESSOR}")
+IF(IOS OR (CMAKE_SYSTEM_NAME STREQUAL "Darwin" AND CMAKE_OSX_ARCHITECTURES MATCHES "^(x86_64|arm64)$"))
+  SET(CPUINFO_TARGET_PROCESSOR "${CMAKE_OSX_ARCHITECTURES}")
+ENDIF()
+
 # ---[ Build flags
 SET(CPUINFO_SUPPORTED_PLATFORM TRUE)
 IF(NOT CMAKE_SYSTEM_PROCESSOR)
@@ -67,9 +65,9 @@
       "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
     SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
   ENDIF()
-ELSEIF(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|AMD64|x86(_64)?|armv[5-8].*|aarch64)$")
+ELSEIF(NOT CPUINFO_TARGET_PROCESSOR MATCHES "^(i[3-6]86|AMD64|x86(_64)?|armv[5-8].*|aarch64|arm64)$")
   MESSAGE(WARNING
-    "Target processor architecture \"${CMAKE_SYSTEM_PROCESSOR}\" is not supported in cpuinfo. "
+    "Target processor architecture \"${CPUINFO_TARGET_PROCESSOR}\" is not supported in cpuinfo. "
     "cpuinfo will compile, but cpuinfo_initialize() will always fail.")
   SET(CPUINFO_SUPPORTED_PLATFORM FALSE)
 ENDIF()
@@ -125,7 +123,7 @@
   src/cache.c)
 
 IF(CPUINFO_SUPPORTED_PLATFORM)
-  IF(NOT CMAKE_SYSTEM_NAME STREQUAL "Emscripten" AND (CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|AMD64|x86(_64)?)$" OR IOS_ARCH MATCHES "^(i386|x86_64)$"))
+  IF(NOT CMAKE_SYSTEM_NAME STREQUAL "Emscripten" AND (CPUINFO_TARGET_PROCESSOR MATCHES "^(i[3-6]86|AMD64|x86(_64)?)$" OR IOS_ARCH MATCHES "^(i386|x86_64)$"))
     LIST(APPEND CPUINFO_SRCS
       src/x86/init.c
       src/x86/info.c
@@ -146,7 +144,7 @@
     ELSEIF(CMAKE_SYSTEM_NAME MATCHES "^(Windows|CYGWIN|MSYS)$")
       LIST(APPEND CPUINFO_SRCS src/x86/windows/init.c)
     ENDIF()
-  ELSEIF(CMAKE_SYSTEM_PROCESSOR MATCHES "^(armv[5-8].*|aarch64)$" OR IOS_ARCH MATCHES "^(armv7.*|arm64.*)$")
+  ELSEIF(CPUINFO_TARGET_PROCESSOR MATCHES "^(armv[5-8].*|aarch64|arm64)$" OR IOS_ARCH MATCHES "^(armv7.*|arm64.*)$")
     LIST(APPEND CPUINFO_SRCS
       src/arm/uarch.c
       src/arm/cache.c)
@@ -163,10 +161,10 @@
         IF(CMAKE_SYSTEM_NAME STREQUAL "Android" AND ANDROID_ABI STREQUAL "armeabi")
           SET_SOURCE_FILES_PROPERTIES(src/arm/linux/aarch32-isa.c PROPERTIES COMPILE_FLAGS -marm)
         ENDIF()
-      ELSEIF(CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
+      ELSEIF(CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64|arm64)$")
         LIST(APPEND CPUINFO_SRCS src/arm/linux/aarch64-isa.c)
       ENDIF()
-    ELSEIF(IOS)
+    ELSEIF(IOS OR (CMAKE_SYSTEM_NAME STREQUAL "Darwin" AND CPUINFO_TARGET_PROCESSOR STREQUAL "arm64"))
       LIST(APPEND CPUINFO_SRCS src/arm/mach/init.c)
     ENDIF()
     IF(CMAKE_SYSTEM_NAME STREQUAL "Android")
@@ -282,8 +280,3 @@
   ENDIF()
 
   IF(CMAKE_SYSTEM_NAME MATCHES "^(Linux|Android)$")
-    ADD_EXECUTABLE(get-current-bench bench/get-current.cc)
-    TARGET_LINK_LIBRARIES(get-current-bench cpuinfo benchmark)
-  ENDIF()
-
-  ADD_EXECUTABLE(init-bench bench/init.cc)

=== deps/clog/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.1 FATAL_ERROR)

INCLUDE(GNUInstallDirs)

# ---[ Project and semantic versioning.
PROJECT(clog C CXX)

# ---[ Options.
SET(CLOG_RUNTIME_TYPE "default" CACHE STRING "Type of runtime library (shared, static, or default) to use")
SET_PROPERTY(CACHE CLOG_RUNTIME_TYPE PROPERTY STRINGS default static shared)
IF(ANDROID)
  OPTION(CLOG_LOG_TO_STDIO "Log errors, warnings, and information to stdout/stderr" OFF)
ELSE()
  OPTION(CLOG_LOG_TO_STDIO "Log errors, warnings, and information to stdout/stderr" ON)
ENDIF()
OPTION(CLOG_BUILD_TESTS "Build clog tests" ON)

# ---[ CMake options
IF(CLOG_BUILD_TESTS)
  ENABLE_TESTING()
ENDIF()

MACRO(CLOG_TARGET_RUNTIME_LIBRARY target)
  IF(MSVC AND NOT CLOG_RUNTIME_TYPE STREQUAL "default")
    IF(CLOG_RUNTIME_TYPE STREQUAL "shared")
      TARGET_COMPILE_OPTIONS(${target} PRIVATE
        "/MD$<$<CONFIG:Debug>:d>")
    ELSEIF(CLOG_RUNTIME_TYPE STREQUAL "static")
      TARGET_COMPILE_OPTIONS(${target} PRIVATE
        "/MT$<$<CONFIG:Debug>:d>")
    ENDIF()
  ENDIF()
ENDMACRO()

# ---[ Download deps
SET(CONFU_DEPENDENCIES_SOURCE_DIR ${CMAKE_SOURCE_DIR}/deps
  CACHE PATH "Confu-style dependencies source directory")
SET(CONFU_DEPENDENCIES_BINARY_DIR ${CMAKE_BINARY_DIR}/deps
  CACHE PATH "Confu-style dependencies binary directory")

IF(CLOG_BUILD_TESTS)
  IF(NOT DEFINED GOOGLETEST_SOURCE_DIR)
    MESSAGE(STATUS "Downloading Google Test to ${CONFU_DEPENDENCIES_SOURCE_DIR}/googletest (define GOOGLETEST_SOURCE_DIR to avoid it)")
    CONFIGURE_FILE(cmake/DownloadGoogleTest.cmake "${CONFU_DEPENDENCIES_BINARY_DIR}/googletest-download/CMakeLists.txt")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
      WORKING_DIRECTORY "${CONFU_DEPENDENCIES_BINARY_DIR}/googletest-download")
    EXECUTE_PROCESS(COMMAND "${CMAKE_COMMAND}" --build .
      WORKING_DIRECTORY "${CONFU_DEPENDENCIES_BINARY_DIR}/googletest-download")
    SET(GOOGLETEST_SOURCE_DIR "${CONFU_DEPENDENCIES_SOURCE_DIR}/googletest" CACHE STRING "Google Test source directory")
  ENDIF()
ENDIF()

# ---[ clog library
ADD_LIBRARY(clog STATIC src/clog.c)
SET_TARGET_PROPERTIES(clog PROPERTIES
  C_STANDARD 99
  C_EXTENSIONS NO)
CLOG_TARGET_RUNTIME_LIBRARY(clog)
SET_TARGET_PROPERTIES(clog PROPERTIES PUBLIC_HEADER include/clog.h)
TARGET_INCLUDE_DIRECTORIES(clog BEFORE PUBLIC include)
IF(CLOG_LOG_TO_STDIO)
  TARGET_COMPILE_DEFINITIONS(clog PRIVATE CLOG_LOG_TO_STDIO=1)
ELSE()
  TARGET_COMPILE_DEFINITIONS(clog PRIVATE CLOG_LOG_TO_STDIO=0)
ENDIF()
IF(ANDROID AND NOT CLOG_LOG_TO_STDIO)
  TARGET_LINK_LIBRARIES(clog PRIVATE log)
ENDIF()

INSTALL(TARGETS clog
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

# ---[ clog tests
IF(CLOG_BUILD_TESTS)
  # ---[ Build google test
  IF(NOT TARGET gtest)
    IF(MSVC AND NOT CLOG_RUNTIME_TYPE STREQUAL "static")
      SET(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
    ENDIF()
    ADD_SUBDIRECTORY(
      "${GOOGLETEST_SOURCE_DIR}"
      "${CONFU_DEPENDENCIES_BINARY_DIR}/googletest")
  ENDIF()

  ADD_EXECUTABLE(clog-test test/clog.cc)
  SET_TARGET_PROPERTIES(clog-test PROPERTIES
    CXX_STANDARD 11
    CXX_EXTENSIONS NO)
  CLOG_TARGET_RUNTIME_LIBRARY(clog-test)
  TARGET_LINK_LIBRARIES(clog-test PRIVATE clog gtest gtest_main)
  ADD_TEST(clog-test clog-test)
ENDIF()

=== debian/changelog ===
cpuinfo (0.0~git20220131.85e931e-1) unstable; urgency=medium

  * New upstream version 0.0~git20220131.85e931e
    There is no ABI/API change since git20201217.5916273, so this snapshot
    should be fine for the PyTorch/v1.8.X LTS release.
  * Install the new pkg-config file in -dev package.
  * Bump Standards-Version to 4.6.0.1 (no change).

 -- Mo Zhou <lumin@debian.org>  Mon, 21 Feb 2022 14:08:05 -0500

## cpuinfo 0.0~git20220617.082deff

=== CMakeLists.txt ===
--- 
+++ 
@@ -214,7 +214,7 @@
   TARGET_COMPILE_DEFINITIONS(cpuinfo_internals PRIVATE _WIN32_WINNT=0x0601)
 ENDIF()
 SET_TARGET_PROPERTIES(cpuinfo PROPERTIES PUBLIC_HEADER include/cpuinfo.h)
-TARGET_INCLUDE_DIRECTORIES(cpuinfo BEFORE PUBLIC include)
+TARGET_INCLUDE_DIRECTORIES(cpuinfo BEFORE PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
 TARGET_INCLUDE_DIRECTORIES(cpuinfo BEFORE PRIVATE src)
 TARGET_INCLUDE_DIRECTORIES(cpuinfo_internals BEFORE PUBLIC include src)
 IF(CPUINFO_LOG_LEVEL STREQUAL "default")
@@ -264,19 +264,14 @@
 TARGET_LINK_LIBRARIES(cpuinfo PRIVATE clog)
 TARGET_LINK_LIBRARIES(cpuinfo_internals PRIVATE clog)
 
-INSTALL(TARGETS cpuinfo
-  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
-  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
-  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
-
-# ---[ cpuinfo micro-benchmarks
-IF(CPUINFO_SUPPORTED_PLATFORM AND CPUINFO_BUILD_BENCHMARKS)
-  # ---[ Build google benchmark
-  IF(NOT TARGET benchmark)
-    SET(BENCHMARK_ENABLE_TESTING OFF CACHE BOOL "")
-    ADD_SUBDIRECTORY(
-      "${GOOGLEBENCHMARK_SOURCE_DIR}"
-      "${CONFU_DEPENDENCIES_BINARY_DIR}/googlebenchmark")
-  ENDIF()
-
-  IF(CMAKE_SYSTEM_NAME MATCHES "^(Linux|Android)$")
+ADD_LIBRARY(${PROJECT_NAME}::cpuinfo ALIAS cpuinfo)
+
+# support find_package(cpuinfo CONFIG)
+INCLUDE(CMakePackageConfigHelpers)
+GET_FILENAME_COMPONENT(CONFIG_FILE_PATH ${CMAKE_CURRENT_BINARY_DIR}/cpuinfo-config.cmake ABSOLUTE)
+CONFIGURE_PACKAGE_CONFIG_FILE(
+  cmake/cpuinfo-config.cmake.in ${CONFIG_FILE_PATH}
+  INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME})
+INSTALL(FILES ${CONFIG_FILE_PATH}
+  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}) # cpuinfo_DIR ${prefix}/share/cpuinfo
+

=== debian/changelog ===
cpuinfo (0.0~git20220617.082deff-2) unstable; urgency=medium

  * Team upload.
  * Install cmake files in the correction location (Closes: #1024772)

 -- Dylan Aïssi <daissi@debian.org>  Sat, 17 Jun 2023 10:04:14 +0200

cpuinfo (0.0~git20220617.082deff-1) unstable; urgency=medium

  * New upstream version 0.0~git20220617.082deff
    This snapshot should be ok for PyTorch/v1.12.X release.
  * Install newly exported cmake config files.

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Jun 2022 21:53:07 -0700

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: science
 Homepage: https://github.com/pytorch/cpuinfo
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0.1
 Vcs-Git: https://salsa.debian.org/deeplearning-team/cpuinfo.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/cpuinfo
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -52,7 +52,6 @@
 Package: libcpuinfo-dev
 Section: libdevel
 Architecture: any
-Multi-Arch: same
 Depends: libcpuinfo0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: CPU INFOrmation library (header file)
  cpuinfo is a library to detect essential for performance optimization

## cpuinfo 0.0~git20220819.8ec7bd9

=== debian/changelog ===
cpuinfo (0.0~git20220819.8ec7bd9-3) unstable; urgency=medium

  * Skip the uarch test which fails on P+E Intel CPUs.
    It fails simply because the upstream has not yet added the
    code for the new architectures. But at least the ISA and
    Cache detection are still functional on the new CPUs.
    (Closes: #1024774)

 -- Mo Zhou <lumin@debian.org>  Mon, 11 Sep 2023 20:12:00 -0400

cpuinfo (0.0~git20220819.8ec7bd9-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 18 Aug 2023 15:53:18 -0400

cpuinfo (0.0~git20220819.8ec7bd9-1) experimental; urgency=medium

  * Upload to experimental.
  * New upstream version 0.0~git20220819.8ec7bd9
  * Please pin to this snapshot for PyTorch/v2.0.1 release.
  * Remove the shlibs:Depends from -dev package.
  * Update lintian overrides.

 -- Mo Zhou <lumin@debian.org>  Sun, 25 Jun 2023 21:03:28 +0000
